SystemOrganization addCategory: #'Settings-Graphics'!

Object subclass: #GraphicFontSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Settings-Graphics'!

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 9/18/2011 10:14'!
fontChoiceButtonForStyle: aSymbol label: aLabel
	| label |
	label := StringMorph contents: aLabel asString font: (TextStyle default fontOfPointSize: (StandardFonts pointSizeForStyleNamed: aSymbol)).
	^ (UITheme current
		newButtonIn: World
		for: self
		getState: nil 
		action: #setFontsToStyleNamed:
		arguments: { aSymbol }
		getEnabled: nil
		getLabel: nil
		help: ('Change font style to ', aLabel) translated)
			label: label;
			yourself
! !

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 9/18/2011 10:14'!
fontSizeRow
	| label |
	^ self theme newRowIn: World for: {
			self theme buttonLabelForText: 'Predefined styles: ' translated.
			self fontChoiceButtonForStyle: #small label: 'Small' translated.
			self fontChoiceButtonForStyle: #medium label: 'Medium' translated.
			self fontChoiceButtonForStyle: #large label: 'Large' translated.
			self fontChoiceButtonForStyle: #veryLarge label: 'Very large' translated.
			self fontChoiceButtonForStyle: #huge label: 'Huge' translated.
	}! !

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 08:15'!
resetAllFontToDefault
	StandardFonts setAllStandardFontsTo: StandardFonts defaultFont.
	SettingBrowser refreshAllSettingBrowsers
	 
! !

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 9/17/2011 17:52'!
resetAllFontToDefaultButton
			^ (self theme 
				newButtonIn: World 
				for: self
				getState: nil
				action: #resetAllFontToDefault
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: 'Force all system fonts to be the default one' translated)
		 		label: (self theme newRowIn: World for: {AlphaImageMorph new image: self theme smallRedoIcon. self theme buttonLabelForText: 'Force all' translated});
		 		yourself.
! !

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 9/18/2011 10:11'!
setFontsToStyleNamed: aSymbol
	StandardFonts setFontsToStyleNamed: aSymbol.
	SettingBrowser refreshAllSettingBrowsers! !

!GraphicFontSettings class methodsFor: 'fonts' stamp: 'AlainPlantec 9/17/2011 22:16'!
standardFontsSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #standardFonts)
		label: 'Standard fonts' translated;
		target: StandardFonts;
		dialog: [self fontSizeRow];
		parent: #appearance;
		order: 4;
		with: [ 
			(aBuilder setting: #defaultFont)
				order: 1;
				description: 'The default text font' translated;
				dialog: (MessageSend receiver: self selector: #resetAllFontToDefaultButton);
				label: 'Default' translated.
			(aBuilder setting: #codeFont) 
				description: 'The standard code font' translated;
				label: 'Code' translated.
			(aBuilder setting: #listFont)
				description: 'The standard list font' translated;
				label: 'List' translated.
			(aBuilder setting: #menuFont)
				description: 'The standard menu font' translated;
				label: 'Menu' translated.
			(aBuilder setting: #buttonFont)
				description: 'The standard button font' translated;
				label: 'Button' translated.
			(aBuilder setting: #windowTitleFont)
				description: 'The standard window title font' translated;
				label: 'Window title' translated.
			(aBuilder setting: #balloonFont)
				description: 'The standard balloon-help font' translated;
				label: 'Balloon-help' translated.
			(aBuilder setting: #haloFont)
				description: 'The morphic halo font' translated;
				label: 'Morphic halo' translated]
				
				! !

!GraphicFontSettings class methodsFor: 'private' stamp: 'AlainPlantec 4/28/2011 12:17'!
theme
	^ UIManager default theme! !
